/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DATA_H
#define DATA_H

#include <gtkmm.h>

namespace Pline
{

class Data
{
public:
	Data();
	virtual ~Data();

	Data* operator=(const Data &oData);
	bool operator==(const Data &oData) const;
	bool operator!=(const Data &oData) const;
	
	const Glib::ustring& getLabel() {return gstLabel;}
	int getPos() {return giPosition;}
	Glib::ustring getSrc() {return gstSrc;}
	
	inline void setLabel(const Glib::ustring& st) {gstLabel = st;}
	inline void setPos(const int i) {giPosition = i;}
	inline void setSrc(const Glib::ustring& st) {gstSrc = st;}

private:
	Glib::ustring   gstLabel;
	int				giPosition;
	Glib::ustring   gstSrc;
};

} // Pline
#endif /* DATA_H */
