/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MKCRYPTFILTER_H
#define MKCRYPTFILTER_H

#include "Filter.h"

#include <gtkmm.h>

namespace Pline
{

#define MKCRYPTFILTER_MAXTRY	    3
#define MKCRYPTFILTER_SLEEP_TRY		100000 // 100 msec

class CryptData;

class MkCryptFilter : public Filter
{
public:
	MkCryptFilter();
	virtual ~MkCryptFilter();

	// ready to enter data
	void askData();
	
	// filter config
	inline const Glib::ustring getFilterName() const {return "MkCrypt";}
	
	// data
	void setSrcData(CryptData *poData);
	
	inline void setCipher(const Glib::ustring& st) {gstCipher = st;}
	inline void setCBC(const Glib::ustring& st) {gstCBC = st;}
	inline void setKeySize(const Glib::ustring& st) {gstKeySize = st;}
	
	// run
	bool run();

protected:

private:
	CryptData *gpoCryptData;
	Glib::ustring gstCipher;
	Glib::ustring gstCBC;
	Glib::ustring gstKeySize;
	Glib::ustring gstPasswd1;
	Glib::ustring gstPasswd2;
	int gciPasswdTry;
	
	const bool isValidPassword();
};

} // Pline	
#endif /* MKCRYPTFILTER_H */
