/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MOUNTDATA_H
#define MOUNTDATA_H

#include <gtkmm.h>

#include "Data.h"

namespace Pline
{

class MountData : public Data
{
public:
	MountData(const Data &oData);
	virtual ~MountData();

	MountData* operator=(const MountData &oMountData);
	bool operator==(const MountData &oMountData) const;
	bool operator!=(const MountData &oMountData) const;
	
	inline const Glib::ustring& getDir() {return gstDir;}
	inline const Glib::ustring& getDirOwner() {return gstDirOwner;}
	inline const Glib::ustring& getDirGroup() {return gstDirGroup;}
	inline unsigned long getDirPerm() {return gulDirPerm;}
	inline bool getDirSetPerm() {return gbSetPerm;}
	inline const Glib::ustring getFSys() {return gstFSys;}
	inline bool getReadOnly() {return gbReadOnly;}
	inline unsigned long getMountFlags() {return gulMountFlags;}
	
	inline bool isEmptyTrash() {return gbEmptyTrash;}
	inline bool isEmptyTrashConfirm() {return gbEmptyTrashConfirm;}
	
	inline void setDir(const Glib::ustring& st) {gstDir = st;}
	inline void setDirOwner(const Glib::ustring& st) {gstDirOwner = st;}
	inline void setDirGroup(const Glib::ustring& st) {gstDirGroup = st;}
	inline void setDirPerm(const unsigned long ul) {gulDirPerm = ul;}
	inline void setDirSetPerm(const bool b) {gbSetPerm = b;}
	inline void setEmptyTrash(const bool b) {gbEmptyTrash = b;}
	inline void setEmptyTrashConfirm(const bool b) {gbEmptyTrashConfirm = b;}
	inline void setFSys(const Glib::ustring& st) {gstFSys = st;}
	inline void setReadOnly(const bool b) {gbReadOnly = b;}
	inline void setMountFlags(const unsigned long ul) {gulMountFlags = ul;}
	
protected:

private:
	Glib::ustring   gstDir;
	Glib::ustring   gstDirOwner;
	Glib::ustring   gstDirGroup;
	unsigned long   gulDirPerm;
	bool 			gbEmptyTrash;
	bool 			gbEmptyTrashConfirm;
	bool			gbSetPerm;
	Glib::ustring   gstFSys;
	bool			gbReadOnly;
	unsigned long   gulMountFlags;
	
	void init();
};

} // Pline
#endif /* MOUNTDATA_H */
