/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PROCESSBASEFILTER_H
#define PROCESSBASEFILTER_H

#include "Filter.h"

#include <gtkmm.h>

namespace Pline
{

class ProcessBaseFilter : public Filter
{
public:
	ProcessBaseFilter();
	~ProcessBaseFilter();

	// filter config
	virtual const Glib::ustring getFilterType() {return "Process";}

	// cancel operations
	inline bool isCanCancel() {return gbCanCancel;}
	bool cancel();
	
	// signals
	inline sigc::signal<void, bool>& signal_cancancel_changed() {return m_signal_cancancel_changed;}
	
protected:
	bool gbStop;
	
	void setCanCancel(const bool b);
	
	virtual bool onCancel();
	
private:
	bool gbCanCancel;
	
	sigc::signal<void, bool> m_signal_cancancel_changed;
};
	
} // Pline
#endif /* PROCESSBASEFILTER_H */
