/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PROPDIALOG_H
#define PROPDIALOG_H

#include "QDialog.h"
#include "UtilGui.h"

#include <gtkmm.h>
#include <vector>

#include "Pline/MountPline.h"

class DialogHelper;
class VolumeConfig;

class PropDialog : public QDialog
{
public:
	PropDialog( BaseObjectType* cobject,
				const Glib::RefPtr<Gtk::Builder>& refGlade);
	~PropDialog();

	void setData(   VolumeConfig *poVolumeConfig,
					std::vector<Glib::ustring> *pvecVolumeConfigLabel,
					std::vector<Pline::MountPline::tDumpStatus> *pvecPlineStatus,
					const Glib::ustring& stFSys,
					const Glib::ustring& stCipher,
					const Glib::ustring& stDiskSize,
					const Glib::ustring& stDiskUsedSpace,
					const Glib::ustring& stDiskAvailableSpace);
	
protected:
	
private:
	UtilGui::tPropDlg gtPropDlg;
	DialogHelper *gpoDialogHelper;	
	
	// data
	VolumeConfig *gpoVolumeConfig;	
	std::vector<Glib::ustring> *gpvecVolumeConfigLabel;
	std::vector<Glib::ustring> gvecFSys;
	std::vector<Pline::MountPline::tDumpStatus> *gpvecPlineStatus;
	Glib::ustring gstFSys;
	Glib::ustring gstCipher;
	
	// Disk usage
	Glib::ustring gstDiskSize;
	Glib::ustring gstDiskUsedSpace;
	Glib::ustring gstDiskAvailableSpace;
	
	// needed for gtkmm bug
	Gtk::FileChooserButton* gpoSourceFileChooser;
	Gtk::FileChooserButton* gpoKeyFileFileChooser;
	
	void buildFSys();
	
	void onApply();
	void onClose();
	
	void onCloneBrowse();
	void onEncrypt();
	void onOptEmptyTrash();
	void onPermissions();
	void onReadOnly();
	void onSource();
	void onUseKeyFile();
	void onUsePassword();

	void updateData(const bool bToScreen);
	void updateExtraStatus();
	bool validate();
};
	
#endif /* PROPDIALOG_H */
