/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UTILGUI_H
#define UTILGUI_H

#include <gtkmm.h>
#include <vector>

class UtilGui
{
public:
	UtilGui();
	~UtilGui();
											
	//
	// CreatePlainDiskImageDialog
	//
	typedef struct _CREATEPLAINDISKIMAGEDLG_
	{
		Gtk::Entry* poSaveAsEntry;
		Gtk::Button* poSaveAsBrowseButton;
		Gtk::Entry* poVolumeLabelEntry;
		Gtk::Entry* poVolumeSizeEntry;
		Gtk::RadioButton* poMRadioButton;
		Gtk::RadioButton* poGRadioButton;
		Gtk::RadioButton* poAllocFullRadioButton;
		Gtk::RadioButton* poAllocCompactRadioButton;
		Gtk::VBox* poFSysVBox;
		Gtk::ComboBoxText* poFSysComboBox;
		Gtk::VBox* poPlaceAfterVBox;
		Gtk::ComboBoxText* poPlaceAfterComboBox;
		
		Gtk::Button* poCancelButton;
		Gtk::Button* poCreateButton;
	}
	tCreatePlainDiskImageDlg;
	
	static void mapCreatePlainDiskImageDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
											tCreatePlainDiskImageDlg& tCreatePlainDiskImageDlgItem);
	
	//
	// CreateDiskImageDialog
	//
	typedef struct _CREATEDISKIMAGEDLG_
	{
		tCreatePlainDiskImageDlg tCreatePlainDiskImageDlgItem;
		
		Gtk::RadioButton* poUsePasswordRadioButton;
		Gtk::RadioButton* poUseKeyFileRadioButton;
		Gtk::FileChooserButton* poKeyFileFileChooser;
		
		Gtk::VBox* poCipherVBox;
		Gtk::ComboBoxText* poCipherComboBox;
		Gtk::VBox* poCBCVBox;
		Gtk::ComboBoxText* poCBCComboBox;
		Gtk::VBox* poKeySizeVBox;
		Gtk::ComboBoxText* poKeySizeComboBox;
	}
	tCreateDiskImageDlg;
	
	static void mapCreateDiskImageDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
										tCreateDiskImageDlg& tCreateDiskImageDlgItem);
	
	//
	// CreateVolumeDialog
	//
	typedef struct _CREATEVOLUMEDLG_
	{
		Gtk::FileChooserButton* poSourceFileChooser;
		Gtk::Entry* poVolumeLabelEntry;
		
		Gtk::VBox* poFSysVBox;
		Gtk::ComboBoxText* poFSysComboBox;
		Gtk::VBox* poPlaceAfterVBox;
		Gtk::ComboBoxText* poPlaceAfterComboBox;
		
		Gtk::RadioButton* poUsePasswordRadioButton;
		Gtk::RadioButton* poUseKeyFileRadioButton;
		Gtk::FileChooserButton* poKeyFileFileChooser;
		
		Gtk::VBox* poCipherVBox;
		Gtk::ComboBoxText* poCipherComboBox;
		Gtk::VBox* poCBCVBox;
		Gtk::ComboBoxText* poCBCComboBox;
		Gtk::VBox* poKeySizeVBox;
		Gtk::ComboBoxText* poKeySizeComboBox;
		
		Gtk::Button* poCancelButton;
		Gtk::Button* poCreateButton;
	}
	tCreateVolumeDlg;
	
	static void mapCreateVolumeDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
									tCreateVolumeDlg& tCreateVolumeDlgItem);
	
	//
	// EnlargeVolumeDialog
	//
	typedef struct _ENLARGEVOLUMEDLG_
	{
		Gtk::Entry* poSaveAsEntry;
		Gtk::Entry* poVolumeLabelEntry;
		
		Gtk::Entry* poVolumeSizeEntry;
		Gtk::Entry* poNewVolumeSizeEntry;
		Gtk::RadioButton* poMRadioButton;
		Gtk::RadioButton* poGRadioButton;
		
		Gtk::Button* poCancelButton;
		Gtk::Button* poEnlargeButton;
	}
	tEnlargeVolumeDlg;
	
	static void mapEnlargeVolumeDlg(Glib::RefPtr<Gtk::Builder> poRefGlade,
									tEnlargeVolumeDlg& tEnlargeVolumeDlgItem);
									
	//
	// InitVolumeDialog
	//
	typedef struct _INITVOLUMEDLG_
	{
		Gtk::Entry* poSaveAsEntry;
		Gtk::Entry* poVolumeLabelEntry;
		
		Gtk::VBox* poFSysVBox;
		Gtk::ComboBoxText* poFSysComboBox;
		
		Gtk::CheckButton* poEncryptedCheckButton;
		Gtk::RadioButton* poUsePasswordRadioButton;
		Gtk::RadioButton* poUseKeyFileRadioButton;
		Gtk::VBox* poKeyFileVBox;
		Gtk::FileChooserButton* poKeyFileFileChooser;
		
		Gtk::VBox* poCipherVBox;
		Gtk::ComboBoxText* poCipherComboBox;
		Gtk::VBox* poCBCVBox;
		Gtk::ComboBoxText* poCBCComboBox;
		Gtk::VBox* poKeySizeVBox;
		Gtk::ComboBoxText* poKeySizeComboBox;
		
		Gtk::Button* poCancelButton;
		Gtk::Button* poInitButton;
	}
	tInitVolumeDlg;
	
	static void mapInitVolumeDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
									tInitVolumeDlg& tInitVolumeDlgItem);
				
	//
	// MountDialog
	//
	typedef struct _MOUNTDLG_
	{
		Gtk::FileChooserButton* poSourceFileChooser;
		Gtk::VBox* poSourceVBox;
		Gtk::FileChooserButton* poMountPointFileChooser;
		Gtk::ToggleButton* poPermToggleButton;
		Gtk::Entry* poVolumeLabelEntry;
		Gtk::VBox* poFSysVBox;
		Gtk::ComboBoxEntryText* poFSysComboBox;
		Gtk::CheckButton* poReadOnlyCheckButton;
		Gtk::CheckButton* poEncryptedCheckButton;
		Gtk::RadioButton* poUsePasswordRadioButton;
		Gtk::RadioButton* poUseKeyFileRadioButton;
		Gtk::FileChooserButton* poKeyFileFileChooser;
		Gtk::VBox* poPlaceAfterVBox;
		Gtk::ComboBoxText* poPlaceAfterComboBox;
		
		Gtk::Button* poCancelButton;
		Gtk::Button* poAddButton;
		Gtk::Button* poMountButton;
	}
	tMountDlg;
	
	static void mapMountDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
								tMountDlg& tMountDlgItem);

	//
	// PermDialog
	//
	typedef struct _PERMDLG_
	{
		Gtk::CheckButton* poSetCheckButton;
		Gtk::VBox* poOwnerVBox;
		Gtk::ComboBoxText* poOwnerComboBox;
		Gtk::VBox* poGroupVBox;
		Gtk::ComboBoxText* poGroupComboBox;
		Gtk::VBox* poOwnerPermVBox;
		Gtk::ComboBoxText* poOwnerPermComboBox;
		Gtk::VBox* poGroupPermVBox;
		Gtk::ComboBoxText* poGroupPermComboBox;
		Gtk::VBox* poOtherPermVBox;
		Gtk::ComboBoxText* poOtherPermComboBox;
		
		Gtk::Button* poButton;
	}
	tPermDlg;
	
	static void mapPermDlg( Glib::RefPtr<Gtk::Builder> poRefGlade,
							tPermDlg& tPermDlgItem);

	//
	// PropDlg
	//
	typedef struct _PROPDLG_STATUS_
	{
		Gtk::Entry* poVolumeLabelEntry;
		Gtk::Entry* poSourceEntry;
		Gtk::Entry* poMountPointEntry;
		Gtk::Entry* poFSysEntry;
		Gtk::Entry* poDiskCapacityEntry;
		Gtk::Entry* poDiskUsedEntry;
		Gtk::Entry* poDiskFreeEntry;
		Gtk::TextView* poExtraTextView;
	}
	tPropDlgStatus;
	
	typedef struct _PROPDLG_MOUNT_
	{
		Gtk::VBox* poSourceVBox;
		Gtk::FileChooserButton* poSourceFileChooser;
		Gtk::FileChooserButton* poMountPointFileChooser;
		Gtk::ToggleButton* poPermToggleButton;
		Gtk::Entry* poVolumeLabelEntry;
		Gtk::VBox* poFSysVBox;
		Gtk::ComboBoxEntryText* poFSysComboBox;
		Gtk::CheckButton* poReadOnlyCheckButton;
		Gtk::CheckButton* poEncryptedCheckButton;
		Gtk::RadioButton* poUsePasswordRadioButton;
		Gtk::RadioButton* poUseKeyFileRadioButton;
		Gtk::VBox* poKeyFileVBox;
		Gtk::FileChooserButton* poKeyFileFileChooser;
		Gtk::VBox* poPlaceAfterVBox;
		Gtk::ComboBoxText* poPlaceAfterComboBox;
	}
	tPropDlgMount;
	
	typedef struct _PROPDLG_CLONE_
	{
		Gtk::Entry* poDestinationEntry;
		Gtk::Button* poDestinationButton;
		Gtk::CheckButton* poOverwriteCheckButton;
	}
	tPropDlgClone;

	typedef struct _PROPDLG_OPTIONS_
	{
		Gtk::CheckButton* poAutomountCheckButton;
		Gtk::CheckButton* poEmptyTrashCheckButton;
		Gtk::CheckButton* poEmptyTrashConfirmCheckButton;
	}
	tPropDlgOptions;
	
	typedef struct _PROPDLG_
	{
		tPropDlgStatus		tStatusItem;
		tPropDlgMount		tMountItem;
		tPropDlgClone		tCloneItem;
		tPropDlgOptions		tOptionsItem;
		
		Gtk::Button* poApplyButton;
		Gtk::Button* poCloseButton;
	}
	tPropDlg;
	
	static void mapPropDlg( Glib::RefPtr<Gtk::Builder> poRefGlade,
							tPropDlg& tPropDlgItem);

protected:

private:

};
	
#endif /* UTILGUI_H */
