/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "UtilSh.h"
#include "QDebug.h"

#include <iostream>
#include <glibmm/i18n.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>

//==============================================================================

UtilSh::UtilSh()
{
}

//==============================================================================

UtilSh::~UtilSh()
{
}

//==============================================================================

bool UtilSh::askCancel( const Glib::ustring& stPrompt, 
						const Glib::ustring& stCancelYes,
						const Glib::ustring& stCancelYesShort)
{
	Glib::ustring stAns = askString(stPrompt);
	
	return (stAns.lowercase() == stCancelYes
			|| stAns.lowercase() == stCancelYesShort) ? true : false;
}

//==============================================================================

Glib::ustring UtilSh::askPassword(const Glib::ustring& stPrompt)
{
	struct termios oflags, nflags;
	char password[128];

	memset((void*)password, '\0', 128);

	/* disabling echo */
	tcgetattr(fileno(stdin), &oflags);
	nflags = oflags;
	nflags.c_lflag &= ~ECHO;
	nflags.c_lflag |= ECHONL;

	if (tcsetattr(fileno(stdin), TCSANOW, &nflags) != 0)
	{
		std::cerr << "tcsetattr";
		return Glib::ustring();
	}

	std::cout << stPrompt;
	if (fgets(password, sizeof(password), stdin))
		password[strlen(password) - 1] = 0;

	/* restore terminal */
	if (tcsetattr(fileno(stdin), TCSANOW, &oflags) != 0)
		std::cerr << "tcsetattr";
	
	return Glib::ustring(password);
}

//==============================================================================

Glib::ustring UtilSh::askString(const Glib::ustring& stPrompt)
{
	char szString[1024];

	memset((void*)szString, '\0', 1024);
	
	std::cout << stPrompt;
	if (fgets(szString, sizeof(szString), stdin))
		szString[strlen(szString) - 1] = 0;
	
	return Glib::ustring(szString);
}

//==============================================================================
