/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "VolumeGuiState.h"
#include "QDebug.h"

//==============================================================================

VolumeGuiState::VolumeGuiState()
{
	geBtnCancelState = VolumeCellRenderer::kBtnHidden;
	geBtnEjectState = VolumeCellRenderer::kBtnHidden;
	geBtnMountState = VolumeCellRenderer::kBtnHidden;
	
	gbShowISO = false;
	giProgressGaugePct = -1;
	giProgressUsedSpacePct = -1;
	
	gbEjectMode = false;
	gbMountMode = false;
	gbProgressMode = false;
}

//==============================================================================

VolumeGuiState::~VolumeGuiState()
{
}

//==============================================================================

void VolumeGuiState::setEjectMode(	const int iUsedSpacePct,
									const bool bISO,
									const Glib::ustring& stInfo)
{
	// set funct params
	giProgressUsedSpacePct = iUsedSpacePct;
	gbShowISO = bISO;
	gstInfo = stInfo;
	
	// buttons
	geBtnEjectState = VolumeCellRenderer::kBtnNormal;
	geBtnMountState = VolumeCellRenderer::kBtnDisabled;
	
	// re-init other
	geBtnCancelState = VolumeCellRenderer::kBtnHidden;
	
	giProgressGaugePct = -1;
	
	// set mode
	gbEjectMode = true;
	gbMountMode = false;
	gbProgressMode = false;
}

//==============================================================================

void VolumeGuiState::setMountMode(const Glib::ustring& stInfo)
{	
	// set funct params
	gstInfo = stInfo;
	
	// buttons
	geBtnMountState = VolumeCellRenderer::kBtnNormal;
	
	// re-init other
	geBtnCancelState = VolumeCellRenderer::kBtnHidden;
	geBtnEjectState = VolumeCellRenderer::kBtnHidden;
	
	gbShowISO = false;
	giProgressGaugePct = -1;
	giProgressUsedSpacePct = -1;
	
	// set mode
	gbEjectMode = false;
	gbMountMode = true;
	gbProgressMode = false;
}

//==============================================================================

void VolumeGuiState::setProgressMode(	const int iProgressPct,
										const bool bCanCancel,
										const Glib::ustring& stInfo)
{
	// set funct params
	giProgressGaugePct = iProgressPct;
	gstInfo = stInfo;
	
	// buttons
	geBtnCancelState = (bCanCancel) ? 
		VolumeCellRenderer::kBtnNormal : VolumeCellRenderer::kBtnDisabled;
	
	// re-init other
	geBtnMountState = VolumeCellRenderer::kBtnHidden;
	geBtnEjectState = VolumeCellRenderer::kBtnHidden;
	
	gbShowISO = false;
	giProgressUsedSpacePct = -1;
	
	// set mode
	gbEjectMode = false;
	gbMountMode = false;
	gbProgressMode = true;
}

//==============================================================================
